/* --------------------------------------------------------------------- */

/*
 *  filter.h  --  FIR filter routines.
 *
 *  Copyright (C) 2000,2001,2002 Tomi Manninen (tomi.manninen@hut.fi)
 *
 *  This file is part of the NEWQPSK modem.
 *
 *  NEWQPSK modem is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  NEWQPSK modem is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* --------------------------------------------------------------------- */

#ifndef _FILTER_H
#define _FILTER_H

#include "complex.h"

/* ---------------------------------------------------------------------- */

#ifdef __i386__
#include "filter-i386.h"
#endif				/* __i386__ */

/* ---------------------------------------------------------------------- */

#ifndef __HAVE_ARCH_MAC
extern inline float mac(const float *a, const float *b, unsigned int size)
{
	float sum = 0;
	unsigned int i;

	for (i = 0; i < size; i++)
		sum += (*a++) * (*b++);
	return sum;
}
#endif				/* __HAVE_ARCH_MAC */

/* ---------------------------------------------------------------------- */

struct filter {
	float filtI[NumFilters][AliasFilterLen];
	float filtQ[NumFilters][AliasFilterLen];
	float bufI[AliasFilterLen + SymbolLen];
	float bufQ[AliasFilterLen + SymbolLen];
	float phase;
	float phaseinc;
};

extern void init_filter(struct filter *, float, float, float);
extern int filter(struct filter *, complex *, complex *);

/* ---------------------------------------------------------------------- */
#endif				/* _FILTER_H */
